// CDBar.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "MainWnd.h"
#include "CDBar.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "CDPlaylistDlg.h"
#include "AboutDlg.h"
#include "SeekDialog.h"
#include "MP3InfoDlg.h"
#include "SettingsDialog.h"
#include "WAEmuWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CSysTrayPlayApp theApp;
extern CEqualizerDlg *EqualizerDlg;
extern CPlaylistDlg *PlaylistDlg;
extern CCDPlaylistDlg *CDPlaylistDlg;
extern CAboutDlg *AboutDlg;
extern CMP3InfoDlg *MP3InfoDlg;
extern CSettingsDialog *SettingsDialog;
extern CWAEmuWnd *WAEmuWnd;
extern CCDBar *CDBar;

/////////////////////////////////////////////////////////////////////////////
// CCDBar dialog


CCDBar::CCDBar(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CCDBar)
	//}}AFX_DATA_INIT
	HDocked=VDocked=true;
	ScrollFlag=FALSE;
	CanResize=false;
}


void CCDBar::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDBar)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_BAR, m_bar);
	DDX_Control(pDX, IDC_VOL, m_vol);
	DDX_Control(pDX, IDC_FORIEPT, m_ipe);
	DDX_Control(pDX, IDC_FORCONTROLS, m_mb);
}


BEGIN_MESSAGE_MAP(CCDBar, CDialog)
	//{{AFX_MSG_MAP(CCDBar)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
	ON_WM_MOVING()
	ON_WM_SIZING()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCDBar message handlers
BOOL CCDBar::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetWindowText("STP MiniBar");

	SetTimer(1,100,NULL);

	CRect rect, rect1, rect2;
	
	m_bar.GetWindowRect(&rect);
	ScreenToClient(&rect);
	l1=rect.left; h1=rect.Height();
	m_vol.GetWindowRect(&rect);
	w1=rect.Width();
	m_ipe.GetWindowRect(&rect);
	w2=rect.Width();

	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	GetWindowRect(&rect2);
	if(pMainFrame->SeekBarW==-1000)
		pMainFrame->SeekBarW=rect2.Width();
	if(pMainFrame->SeekBarX==-1000)
		pMainFrame->SeekBarX=(rect1.right-pMainFrame->SeekBarW)/2;
	if(pMainFrame->SeekBarY==-1000)
		pMainFrame->SeekBarY=rect1.top;
	if(pMainFrame->SeekBarX<rect1.left)
		pMainFrame->SeekBarX=rect1.left;
	if(pMainFrame->SeekBarY<rect1.top)
		pMainFrame->SeekBarY=rect1.top;
	if(pMainFrame->SBDockR||pMainFrame->SeekBarX+pMainFrame->SeekBarW>rect1.right)
		pMainFrame->SeekBarX=rect1.right-pMainFrame->SeekBarW;
	if(pMainFrame->SBDockB||pMainFrame->SeekBarY+(rect2.bottom-rect2.top)>rect1.bottom)
		pMainFrame->SeekBarY=rect1.bottom-(rect2.bottom-rect2.top);

	SetWindowPos(&wndTopMost,pMainFrame->SeekBarX,pMainFrame->SeekBarY,pMainFrame->SeekBarW,rect2.Height(),SWP_NOACTIVATE);

	if(pMainFrame->DockSD)
	{
		CRect rect1,rect2,rect3,rect4;
		GetWindowRect(&rect1);
		GetDesktopWindow()->GetWindowRect(&rect2);
		::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
		FindWindow("Shell_TrayWnd",NULL)->GetWindowRect(&rect4);
		SetWindowPos(NULL,(rect3.right-350)/2,(rect4.bottom<rect2.bottom)?rect3.bottom-rect1.Height():rect3.top,350,rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
	}

	GetClientRect(&rect);

	m_bar.SetWindowPos(NULL,0,0,rect.Width()-l1-w1-w2,h1,SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
	m_vol.SetWindowPos(NULL,rect.Width()-w1-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	m_ipe.SetWindowPos(NULL,rect.Width()-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

	m_bar.SetRange(0,1000);

	if(pMainFrame->CDStatus!=CDSTOPPED)
	{
		CString buf,buf2;
		char buf3[64];
		mciSendString("status stp position",buf3,64,NULL);
		buf=buf3;
		int q=atoi(buf.Left(2));
		buf2.Format("status stp length track %d",q);
		mciSendString(buf2,buf3,64,NULL);
		buf2=buf3;
		int l=atoi(buf2.Left(2))*60+atoi(buf2.Mid(3,2));
		buf=buf.Mid(3,5);
		int p=atoi(buf.Left(2))*60+atoi(buf.Right(2));
		
		if(pMainFrame->ShowRemainingTime)
		{
			if(pMainFrame->ShowTTT)
				CDBar->CurTime.Format("%02d:%02d/%02d:%02d",(l-p)/60,(l-p)%60,l/60,l%60);
			else
				CDBar->CurTime.Format("%02d:%02d",(l-p)/60,(l-p)%60);
		} else
		{
			if(pMainFrame->ShowTTT)
				CDBar->CurTime.Format("%s/%02d:%02d",buf,l/60,l%60);
			else
				CDBar->CurTime.Format("%s",buf);
		}		

		CurTrack=pMainFrame->GetCDTrackTitle(q);
		m_bar.SetPos((int)((float)p/(float)l*(float)1000));
	} else
	{
		CurTrack="";
		m_bar.SetPos(0);
	}

	m_ipe.Create(IDB_TRACKS,48,15);
	m_mb.Create(IDB_MB,60,15);

	m_vol.SetRange(0,100);

	m_vol.SetPos(pMainFrame->CurrentVolume);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCDBar::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CPoint thePoint=point;
	ClientToScreen(&thePoint);
	CRect rect;
	GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
	if(thePoint.x>=rect.left+(rect.right-rect.left)*4/5&&
	   thePoint.x<=rect.right&&
	   thePoint.y>=rect.top+(rect.bottom-rect.top)/3&&
	   thePoint.y<=rect.bottom)
	{
		ReleaseCapture();
		SendMessage(0xA1,2,0);
	}
}

void CCDBar::OnMoving( UINT nSide, LPRECT lpRect )
{
	if(pMainFrame->DockSD)
	{
		GetWindowRect(lpRect);
		return;
	}
	CRect rect1;
    ::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	int newx=lpRect->left,newy=lpRect->top;

	if(HDocked)
	{
		if(abs(lpRect->right-rect1.right)<5)
		{
			if(abs(lpRect->right-rect1.right)>1)
			{
				newx=lpRect->left;
				HDocked=false;
			} else
				newx=rect1.right-(lpRect->right-lpRect->left);
		}
		if(abs(lpRect->left)<5)
		{
			if(abs(lpRect->left-rect1.left)>1)
			{
				newx=lpRect->left;
				HDocked=false;
			} else
				newx=rect1.left;
		}
	}
	else
	{
		if(abs(lpRect->right-rect1.right)<5)
		{
			HDocked=true;
			newx=rect1.right-(lpRect->right-lpRect->left);
		}
		if(abs(lpRect->left-rect1.left)<5)
		{
			HDocked=true;
			newx=rect1.left;
		}
	}
	if(VDocked)
	{
		if(abs(lpRect->bottom-rect1.bottom)<5)
		{
			if(abs(lpRect->bottom-rect1.bottom)>1)
			{
				newy=lpRect->top;
				VDocked=false;
			} else
				newy=rect1.bottom-(lpRect->bottom-lpRect->top);
		}
		if(abs(lpRect->top-rect1.top)<5)
		{
			if(abs(lpRect->top-rect1.top)>1)
			{
				newy=lpRect->top;
				VDocked=false;
			} else
				newy=rect1.top;
		}
	}
	else
	{
		if(abs(lpRect->bottom-rect1.bottom)<5)
		{
			VDocked=true;
			newy=rect1.bottom-(lpRect->bottom-lpRect->top);
		}
		if(abs(lpRect->top-rect1.top)<5)
		{
			VDocked=true;
			newy=rect1.top;
		}
	}

	lpRect->right=newx+(lpRect->right-lpRect->left);lpRect->left=newx;
	lpRect->bottom=newy+(lpRect->bottom-lpRect->top);lpRect->top=newy;
}

void CCDBar::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CPoint thePoint=point;
	ClientToScreen(&thePoint);
	CRect rect;
	GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
	if(thePoint.x>=rect.left&&
	   thePoint.x<=rect.right&&
	   thePoint.y>=rect.top&&
	   thePoint.y<=rect.bottom)
	{
		if(thePoint.x<rect.left+(rect.right-rect.left)*4/5)
			pMainFrame->ShowCDTracksMenu(2);
		else
			if(thePoint.y<rect.top+(rect.bottom-rect.top)/3)
			{
				SaveWindowPosAndDestroy();
			}
	}
	else
	{
		GetDlgItem(IDC_FORCONTROLS)->GetWindowRect(&rect);
		if(thePoint.x>=rect.left&&
		   thePoint.x<=rect.right&&
		   thePoint.y>=rect.top&&
		   thePoint.y<=rect.bottom)
		{
			if(thePoint.x<rect.left+(rect.right-rect.left)*1/5)
				OnPlay();
			else
			if(thePoint.x<rect.left+(rect.right-rect.left)*2/5)
				OnPause();
			else
			if(thePoint.x<rect.left+(rect.right-rect.left)*3/5)
				OnStop();
			else
			if(thePoint.x<rect.left+(rect.right-rect.left)*4/5)
				OnPrev();
			else
				OnNext();
		}
	}

}

void CCDBar::OnRButtonUp(UINT nFlags, CPoint point) 
{
	pMainFrame->ShowCDPopup(2);	
}

void CCDBar::OnPlay() 
{
	if(pMainFrame->CDStatus==CDPAUSED)
	{
		CString buf,buf3;
		char buf2[64];
		mciSendString("status stp position",buf2,64,NULL);
		buf=buf3=buf2;
		int q=atoi(buf.Left(buf.Find(':')));
		mciSendString("status stp number of tracks",buf2,64,NULL);
		if(q<atoi(buf2))
			buf.Format("play stp from %s to %d notify",buf,q+1);
		else
			buf.Format("play stp from %s notify",buf3);
		mciSendString(buf,NULL,0,pMainFrame->m_hWnd);
		pMainFrame->CDStatus=CDPLAYING;
		pMainFrame->UpdMBTRCD();
	}
	else
	if(pMainFrame->CDStatus==CDSTOPPED)
	{
		mciSendString("close stp",NULL,0,NULL);
		mciSendString(pMainFrame->CDOpenString, NULL, 0, NULL);
		mciSendString("set stp time format tmsf",NULL,0,NULL);
		int i;
		char buf2[64];
		CString buf;
		mciSendString("status stp number of tracks",buf2,64,NULL);
		if(pMainFrame->ShuffleMode)
		{
			i=pMainFrame->NextRandCD(0,atoi(buf2),true);
		} else
		{
			i=pMainFrame->NextOrderCD(-1,true);
		}
		pMainFrame->CurrentCD=i;
		if(i<atoi(buf2))
			buf.Format("play stp from %d to %d notify",i,i+1);
		else
			buf.Format("play stp from %d notify",i);

		if(!mciSendString(buf, NULL, 0, pMainFrame->m_hWnd))
		{
			pMainFrame->CDStatus=CDPLAYING;
			pMainFrame->Notified=true;
		}
		pMainFrame->UpdMBTRCD();
	}
	
}

void CCDBar::OnPause() 
{
	if(pMainFrame->CDStatus==CDPAUSED)
	{
		CString buf,buf3;
		char buf2[64];
		mciSendString("status stp position",buf2,64,NULL);
		buf=buf3=buf2;
		int q=atoi(buf.Left(buf.Find(':')));
		mciSendString("status stp number of tracks",buf2,64,NULL);
		if(q<atoi(buf2))
			buf.Format("play stp from %s to %d notify",buf,q+1);
		else
			buf.Format("play stp from %s notify",buf3);
		mciSendString(buf,NULL,0,pMainFrame->m_hWnd);
		pMainFrame->CDStatus=CDPLAYING;
		pMainFrame->UpdMBTRCD();
	}
	else
	if(pMainFrame->CDStatus==CDPLAYING)
	{
		mciSendString("pause stp", NULL, 0, NULL);	
		pMainFrame->CDStatus=CDPAUSED;
		pMainFrame->UpdMBTRCD();
	}	
}

void CCDBar::OnNext() 
{
	if(pMainFrame->CDStatus!=CDSTOPPED)
	{
		CString buf;
		char buf2[64];
		int q=pMainFrame->CurrentCD;
		mciSendString("status stp number of tracks",buf2,64,NULL);
		if(pMainFrame->ShuffleMode)
		{
			q=pMainFrame->NextRandCD(q,atoi(buf2),true);
		} else q=pMainFrame->NextOrderCD(q,true);
		if(q>atoi(buf2)||q<1) return;
		pMainFrame->CurrentCD=q;
		if(q<atoi(buf2))
			buf.Format("play stp from %d to %d notify",q,q+1);
		else
			buf.Format("play stp from %d notify",q);
		if(!mciSendString(buf,NULL,0,pMainFrame->m_hWnd))
		{
			pMainFrame->CDStatus=CDPLAYING;
			pMainFrame->Notified=true;
		}
		pMainFrame->UpdMBTRCD();
	}	
}

void CCDBar::OnPrev() 
{
	if(pMainFrame->CDStatus!=CDSTOPPED)
	{
		CString buf;
		char buf2[64];
		int q=pMainFrame->CurrentCD;
		mciSendString("status stp number of tracks",buf2,64,NULL);
		if(pMainFrame->ShuffleMode)
		{
			q=pMainFrame->NextRandCD(q,atoi(buf2),false);
		} else q=pMainFrame->NextOrderCD(q,false);
		if(q>atoi(buf2)||q<1) return;
		pMainFrame->CurrentCD=q;
		if(q<atoi(buf2))
			buf.Format("play stp from %d to %d notify",q,q+1);
		else
			buf.Format("play stp from %d notify",q);
		if(!mciSendString(buf,NULL,0,pMainFrame->m_hWnd))
		{
			pMainFrame->CDStatus=CDPLAYING;
			pMainFrame->Notified=true;
		}
		pMainFrame->UpdMBTRCD();
	}	
}

void CCDBar::OnStop() 
{
	mciSendString("stop stp", NULL, 0, NULL);
	pMainFrame->CDStatus=CDSTOPPED;
	pMainFrame->UpdMBTRCD();
}

BEGIN_MESSAGE_MAP(CMyPrBar2,CProgressCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

CMyPrBar2::CMyPrBar2():
	CProgressCtrl()
{
	MemDCCreated=false;
}

BOOL CMyPrBar2::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CMyPrBar2::OnPaint() 
{
	CPaintDC dc(this);

	if(!MemDCCreated)
	{	
		CRect rect;
		GetClientRect(&rect);

		memDC.CreateCompatibleDC(&dc);
		memBitmap.CreateCompatibleBitmap(&dc, width=rect.Width(), height=rect.Height());
		memDC.SelectObject(&memBitmap);
		
		MemDCCreated=true;
	}

	memDC.FillSolidRect(0,0,width,height, ::GetSysColor(COLOR_BTNFACE));


	if(CDBar->CurTrack!="")
	{
		DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);
		
		RECT r;

		CFont MyFont;
		MyFont.CreatePointFont(70,"Small Fonts");
		CFont *pFont=memDC.SelectObject(&MyFont);
		int nBkMode = memDC.SetBkMode(TRANSPARENT);
		COLORREF crText=memDC.SetTextColor(::GetSysColor(COLOR_MENUTEXT));
		r.left=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits());r.top=1;r.right=width-2;r.bottom=height-1;
		memDC.DrawText(CDBar->CurTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		r.left=2;r.top=1;r.right=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits());r.bottom=height-1;
		memDC.DrawText(CDBar->CurTrack, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		
		memDC.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		r.left=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits());r.top=1;r.right=width-2;r.bottom=height-1;
		if(r.right>width*GetPos()/1000) r.right=width*GetPos()/1000+1;
		memDC.DrawText(CDBar->CurTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		r.left=2;r.top=1;r.right=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits());r.bottom=height-1;
		if(r.right>width*GetPos()/1000) r.right=width*GetPos()/1000+1;
		memDC.DrawText(CDBar->CurTrack, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

		memDC.SetTextColor(crText); 
		memDC.SetBkMode(nBkMode);
		memDC.SelectObject(pFont);
	} else
	{
		DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);
		
		RECT r;

		CFont MyFont;
		MyFont.CreatePointFont(70,"Small Fonts");
		CFont *pFont=memDC.SelectObject(&MyFont);
		int nBkMode = memDC.SetBkMode(TRANSPARENT);
		COLORREF crText=memDC.SetTextColor(::GetSysColor(COLOR_MENUTEXT));

		r.left=1;r.top=1;r.right=width-1;r.bottom=height-1;
		memDC.DrawText("STP CD player", -1, &r, DT_CENTER | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		
		memDC.SetTextColor(crText); 
		memDC.SetBkMode(nBkMode);
		memDC.SelectObject(pFont);
	}

	dc.BitBlt(0, 0, width, height,
				&memDC, 0, 0, SRCCOPY);
}

void CMyPrBar2::OnRButtonUp(UINT nFlags, CPoint point) 
{
	pMainFrame->ShowCDPopup(2);
}

void CCDBar::OnClose() 
{
	SaveWindowPosAndDestroy();
	
	CDialog::OnClose();
}

void CMyPrBar2::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(pMainFrame->CDStatus==CDPLAYING)
	{
		CDBar->ScrollFlag=TRUE;

		CRect rect;
		GetClientRect(&rect);
		int newpos=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)1000/(float)(rect.Width()));

		CString buf;
		char buf2[64];
		mciSendString("status stp position",buf2,64,NULL);
		buf=buf2;
		int q=atoi(buf.Left(2));
		buf.Format("status stp length track %d",q);
		mciSendString(buf,buf2,64,NULL);
		buf=buf2;buf=buf.Left(5);
		int l=atoi(buf.Left(2))*60+atoi(buf.Right(2));
		int p=(int)((float)l*(float)newpos/(float)1000);
		if(pMainFrame->ShowRemainingTime)
		{
			if(pMainFrame->ShowTTT)
				CDBar->CurTime.Format("%02d:%02d/%02d:%02d",(l-p)/60,(l-p)%60,l/60,l%60);
			else
				CDBar->CurTime.Format("%02d:%02d",(l-p)/60,(l-p)%60);
		} else
		{
			if(pMainFrame->ShowTTT)
				CDBar->CurTime.Format("%02d:%02d/%02d:%02d",p/60,p%60,l/60,l%60);
			else
				CDBar->CurTime.Format("%02d:%02d",p/60,p%60);
		}

		SetPos(newpos);
		SetCapture();
	}
}

void CMyPrBar2::OnMouseMove(UINT nFlags, CPoint point)
{
	if(pMainFrame->CDStatus==CDPLAYING&&(nFlags&MK_LBUTTON)&&CDBar->ScrollFlag)
	{
		CRect rect;
		GetClientRect(&rect);
		int newpos=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)1000/(float)(rect.Width()));

		CString buf;
		char buf2[64];
		mciSendString("status stp position",buf2,64,NULL);
		buf=buf2;
		int q=atoi(buf.Left(2));
		buf.Format("status stp length track %d",q);
		mciSendString(buf,buf2,64,NULL);
		buf=buf2;buf=buf.Left(5);
		int l=atoi(buf.Left(2))*60+atoi(buf.Right(2));
		int p=(int)((float)l*(float)newpos/(float)1000);
		if(pMainFrame->ShowRemainingTime)
		{
			if(pMainFrame->ShowTTT)
				CDBar->CurTime.Format("%02d:%02d/%02d:%02d",(l-p)/60,(l-p)%60,l/60,l%60);
			else
				CDBar->CurTime.Format("%02d:%02d",(l-p)/60,(l-p)%60);
		} else
		{
			if(pMainFrame->ShowTTT)
				CDBar->CurTime.Format("%02d:%02d/%02d:%02d",p/60,p%60,l/60,l%60);
			else
				CDBar->CurTime.Format("%02d:%02d",p/60,p%60);
		}

		SetPos(newpos);
	}
}

void CMyPrBar2::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(pMainFrame->CDStatus==CDPLAYING&&CDBar->ScrollFlag)
	{
		CRect rect;
		GetClientRect(&rect);
		int newpos=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)1000/(float)(rect.Width()));

		CString buf;
		char buf2[64];
		mciSendString("status stp position",buf2,64,NULL);
		buf=buf2;
		int q=atoi(buf.Left(2));
		buf.Format("status stp length track %d",q);
		mciSendString(buf,buf2,64,NULL);
		buf=buf2;buf=buf.Left(5);
		int l=atoi(buf.Left(2))*60+atoi(buf.Right(2));
		l=(int)((float)l*(float)newpos/(float)1000);
		
		pMainFrame->CurrentCD=q;
		mciSendString("status stp number of tracks",buf2,64,NULL);
		if(q<atoi(buf2))
			buf.Format("play stp from %d:%d:%d to %d notify",q,l/60,l%60,q+1);
		else
			buf.Format("play stp from %d:%d:%d notify",q,l/60,l%60);
		mciSendString(buf,NULL,0,pMainFrame->m_hWnd);
		pMainFrame->CDStatus=CDPLAYING;
		pMainFrame->Notified=true;
		pMainFrame->UpdMBTRCD();
		//SetPos(newpos);
		CDBar->ScrollFlag=FALSE;
		::ReleaseCapture();
	}
}

void CCDBar::OnDestroy() 
{
	CDialog::OnDestroy();
	
	m_ipe.Delete();
	m_mb.Delete();
}

void CCDBar::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->SeekBarX=rect.left;
	pMainFrame->SeekBarY=rect.top;
	CRect rect1;
	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	pMainFrame->SBDockR=((rect.right==rect1.right&&!pMainFrame->DockSD)?1:0);
	pMainFrame->SBDockB=((rect.bottom==rect1.bottom&&!pMainFrame->DockSD)?1:0);

	DestroyWindow();
	CDBar=NULL;
}

void CCDBar::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent==1)
	{
		if(pMainFrame->DockSD)
		{
			CWnd *w=GetForegroundWindow();
			if(w!=NULL&&
			   w->m_hWnd!=pMainFrame->m_hWnd&&
			   !(::GetWindow(w->m_hWnd, GW_OWNER)!=NULL&&::GetWindow(w->m_hWnd, GW_OWNER)==pMainFrame->m_hWnd)&&
			   !(::GetWindow(::GetWindow(w->m_hWnd, GW_OWNER), GW_OWNER)!=NULL&&::GetWindow(::GetWindow(w->m_hWnd, GW_OWNER), GW_OWNER)==pMainFrame->m_hWnd)&&
			   !(::GetWindow(::GetWindow(::GetWindow(w->m_hWnd, GW_OWNER), GW_OWNER), GW_OWNER)!=NULL&&::GetWindow(::GetWindow(::GetWindow(w->m_hWnd, GW_OWNER), GW_OWNER), GW_OWNER)==pMainFrame->m_hWnd)&&
			   w->m_hWnd!=::FindWindow("Shell_TrayWnd",NULL))
			{
				CRect rect, rect1, rect2;
				w->GetWindowRect(&rect);
				GetDesktopWindow()->GetWindowRect(&rect2);
				GetWindowRect(&rect1);
				int sbcnt=((w->GetStyle()&WS_SYSMENU)?1:0)+((w->GetStyle()&WS_MINIMIZEBOX)?1:0)+((w->GetStyle()&WS_MINIMIZEBOX)?1:0);
				if(rect==rect2||(w->IsWindowVisible()&&(w->GetStyle()&WS_CAPTION)&&!(w->GetExStyle()&WS_EX_TOOLWINDOW))&&!(w->GetExStyle()&WS_EX_TOPMOST)&&rect.Width()-GetSystemMetrics(SM_CXSIZE)*((float)sbcnt+.5)>200)
				{
					int neww=200;
					if(rect.Width()>350) neww=250;
					if(rect.Width()>550) neww=300;
					if(rect.Width()>700) neww=350;
					int newx=rect.right-neww-GetSystemMetrics(SM_CXSIZE)*((float)sbcnt+.5);
					int newy=rect.top+((w->GetStyle()&WS_THICKFRAME)?1:0);
					if(rect==rect2)
					{
						CRect rect3,rect4;
						::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
						FindWindow("Shell_TrayWnd",NULL)->GetWindowRect(&rect4);
						SetWindowPos(NULL,(rect3.right-350)/2,(rect4.bottom<rect2.bottom)?rect3.bottom-rect1.Height():rect3.top,350,rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
					}
					else
					{
						if(newx!=rect1.left||newy!=rect1.top)
							SetWindowPos(NULL,newx,newy,neww,rect1.Height(),SWP_NOZORDER | SWP_NOACTIVATE);
					}
				}
			} else
			if(w==NULL)
			{
				CRect rect1,rect2,rect3,rect4;
				GetWindowRect(&rect1);
				GetDesktopWindow()->GetWindowRect(&rect2);
				::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
				FindWindow("Shell_TrayWnd",NULL)->GetWindowRect(&rect4);
				SetWindowPos(NULL,(rect3.right-350)/2,(rect4.bottom<rect2.bottom)?rect3.bottom-rect1.Height():rect3.top,350,rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
			}
		}
	}	
	CDialog::OnTimer(nIDEvent);
}

void CCDBar::OnSizing( UINT nSide, LPRECT lpRect )
{
	if(pMainFrame->DockSD)
	{
		GetWindowRect(lpRect);
		return;
	}
	CRect r;
	GetWindowRect(&r);
	lpRect->top=r.top;
	lpRect->bottom=r.bottom;
	if(lpRect->right-lpRect->left<200)
	{
		if(lpRect->left>r.left)
			lpRect->left=lpRect->right-200;
		else
			lpRect->right=lpRect->left+200;
	}
}

void CCDBar::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(CanResize)
	{
		m_bar.memDC.DeleteDC();
		m_bar.memBitmap.DeleteObject();
		m_bar.MemDCCreated=false;	

		CRect rect;
		GetClientRect(&rect);

		m_bar.SetWindowPos(NULL,0,0,rect.Width()-l1-w1-w2,h1,SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_vol.SetWindowPos(NULL,rect.Width()-w1-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_ipe.SetWindowPos(NULL,rect.Width()-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_bar.RedrawWindow();
		m_vol.RedrawWindow();
		m_ipe.RedrawWindow();
	}
}

void CCDBar::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	CanResize=bShow?true:false;	
}
