// CDPlaylistDlg.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "CDPlaylistDlg.h"
#include "MainWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CCDPlaylistDlg *CDPlaylistDlg;

/////////////////////////////////////////////////////////////////////////////
// CCDPlaylistDlg dialog


CCDPlaylistDlg::CCDPlaylistDlg(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CCDPlaylistDlg)
	m_title = _T("");
	m_artist = _T("");
	m_trackname = _T("");
	//}}AFX_DATA_INIT
}


void CCDPlaylistDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDPlaylistDlg)
	DDX_Control(pDX, IDC_AVAILABLE, m_available);
	DDX_Control(pDX, IDC_PLAYLIST, m_playlist);
	DDX_Text(pDX, IDC_TITLE, m_title);
	DDX_Text(pDX, IDC_ARTIST, m_artist);
	DDX_Text(pDX, IDC_TRACKNAME, m_trackname);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCDPlaylistDlg, CDialog)
	//{{AFX_MSG_MAP(CCDPlaylistDlg)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_LEFT, OnLeft)
	ON_BN_CLICKED(IDC_RIGHT, OnRight)
	ON_LBN_DBLCLK(IDC_PLAYLIST, OnDblclkPlaylist)
	ON_LBN_DBLCLK(IDC_AVAILABLE, OnDblclkAvailable)
	ON_LBN_SELCHANGE(IDC_AVAILABLE, OnSelchangeAvailable)
	ON_BN_CLICKED(IDC_SET, OnSet)
	ON_EN_CHANGE(IDC_TRACKNAME, OnChangeTrackname)
	ON_EN_CHANGE(IDC_ARTIST, OnChangeArtist)
	ON_EN_CHANGE(IDC_TITLE, OnChangeTitle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCDPlaylistDlg message handlers

BOOL CCDPlaylistDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetIcon(pMainFrame->StpIcon, TRUE);
	SetIcon(pMainFrame->StpIconSm, FALSE);

	SetWindowPos(&wndTopMost,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE|SWP_NOACTIVATE);

	CString buf,buf1,tmp1,tmp2;
	char buf2[64];
	char trackbuf[256];

	mciSendString("info stp identity",buf2,64,NULL);
	cdid.Format("%X",atoi(buf2));

	::GetPrivateProfileString(cdid,"Artist","",trackbuf,256,"CDPLAYER.INI");
	m_artist=trackbuf;

	::GetPrivateProfileString(cdid,"Title","",trackbuf,256,"CDPLAYER.INI");
	m_title=trackbuf;

	UpdateData(FALSE);

	GetDlgItem(IDOK)->EnableWindow(m_artist!=""&&m_title!="");

	char orderbuf[256];
	::GetPrivateProfileString(cdid,"order","",orderbuf,256,"CDPLAYER.INI");
	mciSendString("status stp number of tracks",buf2,64,NULL);
	int q=atoi(buf2),qq;

	trks.RemoveAll();
	bool ordered=false;
	if(strcmp(orderbuf,"")!=0)
	{
		ordered=true;
		CString buf=orderbuf;
		buf.TrimLeft();buf.TrimRight();
		buf=buf+" ";
		do
		{
			trks.Add(1+atoi(buf.Left(buf.Find(' '))));
			buf=buf.Mid(buf.Find(' ')+1);
		} while(buf.GetLength()>0);
		qq=trks.GetSize();
	}
	
	if(q>0)
	{
		CMenu tmenu;
		tmenu.CreatePopupMenu();

		for(int i=0;i<q;i++)
		{
			buf.Format("status stp length track %d",i+1);
			mciSendString(buf,buf2,64,NULL);
			buf=buf2;
			buf=buf.Left(5);
			tmp1.Format("%d",i);
			tmp2.Format("Track %d",i+1);
			::GetPrivateProfileString(cdid,tmp1,tmp2,trackbuf,256,"CDPLAYER.INI");
			buf1.Format("%s (%s)",trackbuf,buf);
			m_available.AddString(buf1);
			if(!ordered)
			{
				m_playlist.AddString(buf1);
				trks.Add(i+1);
			}
		}

		if(ordered)
		for(int i=0;i<qq;i++)
		{
			buf.Format("status stp length track %d",trks[i]);
			mciSendString(buf,buf2,64,NULL);
			buf=buf2;
			buf=buf.Left(5);
			tmp1.Format("%d",trks[i]-1);
			tmp2.Format("Track %d",trks[i]);
			::GetPrivateProfileString(cdid,tmp1,tmp2,trackbuf,256,"CDPLAYER.INI");
			buf1.Format("%s (%s)",trackbuf,buf);
			m_playlist.AddString(buf1);
		}
	}	


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCDPlaylistDlg::OnOK() 
{
	if(GetFocus()->GetDlgCtrlID()==IDC_TRACKNAME)
	{
		OnSet();
		return;
	}

	UpdateData(TRUE);
	if(cdid!="0")
	{
		::WritePrivateProfileString(cdid,"Artist",m_artist,"CDPLAYER.INI");
		::WritePrivateProfileString(cdid,"Title",m_title,"CDPLAYER.INI");
		CString buf,buf2;
		int i;
		for(i=0;i<m_available.GetCount();i++)
		{
			m_available.GetText(i,buf);
			buf=buf.Left(buf.ReverseFind('(')-1);
			buf2.Format("%d",i);
			::WritePrivateProfileString(cdid,buf2,buf,"CDPLAYER.INI");
		}
		buf="";
		for(i=0;i<trks.GetSize();i++)
		{
			buf2.Format("%d ",trks[i]-1);
			buf+=buf2;
		}
		buf.TrimRight();
		::WritePrivateProfileString(cdid,"order",buf,"CDPLAYER.INI");
		buf.Format("%d",trks.GetSize());
		::WritePrivateProfileString(cdid,"numplay",buf,"CDPLAYER.INI");
		buf.Format("%d",m_available.GetCount());
		::WritePrivateProfileString(cdid,"NumTracks",buf,"CDPLAYER.INI");

	}
	DestroyWindow();
	CDPlaylistDlg=NULL;		
}

void CCDPlaylistDlg::OnCancel() 
{
	DestroyWindow();
	CDPlaylistDlg=NULL;		
}

void CCDPlaylistDlg::OnClose() 
{
	DestroyWindow();
	CDPlaylistDlg=NULL;		
}

void CCDPlaylistDlg::OnLeft() 
{
	CString buf;
	int i,j;
	bool flag;
	i=m_available.GetCurSel();
	if(i==LB_ERR) return;
	flag=true;
	for(j=0;j<trks.GetSize();j++)
	{
		if(trks[j]==i+1)
		{
			flag=false;
			break;
		}
	}
	if(flag)
	{
		m_available.GetText(i,buf);
		m_playlist.AddString(buf);
		trks.Add(i+1);
	}
}

void CCDPlaylistDlg::OnRight() 
{
	int i=m_playlist.GetCurSel();
	if(i==LB_ERR) return;
	m_playlist.DeleteString(i);
	trks.RemoveAt(i);
}

void CCDPlaylistDlg::OnDblclkPlaylist() 
{
	OnRight();
}

void CCDPlaylistDlg::OnDblclkAvailable() 
{
	OnLeft();
}

void CCDPlaylistDlg::OnSelchangeAvailable() 
{
	CString buf="";
	int q;
	if((q=m_available.GetCurSel())!=LB_ERR)
	{
		m_available.GetText(q,buf);
		buf=buf.Left(buf.ReverseFind('(')-1);
	}
	GetDlgItem(IDC_TRACKNAME)->SetWindowText(buf);
	((CEdit*)GetDlgItem(IDC_TRACKNAME))->SetSel(0,-1);
}

void CCDPlaylistDlg::OnSet() 
{
	int q;
	if((q=m_available.GetCurSel())!=LB_ERR)
	{
		CString buf,buf2;
		GetDlgItem(IDC_TRACKNAME)->GetWindowText(buf);
		m_available.GetText(q,buf2);
		buf=buf+buf2.Mid(buf2.ReverseFind('(')-1);
		m_available.DeleteString(q);
		m_available.InsertString(q,buf);
		m_available.SetCurSel((q<m_available.GetCount()-1)?q+1:0);

		int i=m_playlist.GetCurSel(),j;
		for(j=0;j<trks.GetSize();j++)
		{
			if(trks[j]==q+1)
			{
				m_playlist.DeleteString(j);
				m_playlist.InsertString(j,buf);
				break;
			}
		}

		OnSelchangeAvailable();
	}
}

void CCDPlaylistDlg::OnChangeTrackname() 
{
	CString buf;
	GetDlgItem(IDC_TRACKNAME)->GetWindowText(buf);
	GetDlgItem(IDC_SET)->EnableWindow(buf!="");
}

void CCDPlaylistDlg::OnChangeArtist() 
{
	CString buf;
	GetDlgItem(IDC_ARTIST)->GetWindowText(buf);
	GetDlgItem(IDOK)->EnableWindow(buf!="");
}

void CCDPlaylistDlg::OnChangeTitle() 
{
	CString buf;
	GetDlgItem(IDC_TITLE)->GetWindowText(buf);
	GetDlgItem(IDOK)->EnableWindow(buf!="");
}
