// SeekDialog.cpp : implementation file
//

#include "stdafx.h"
#include "systrayplay.h"
#include "MainWnd.h"
#include "EqualizerDlg.h"
#include "PlaylistDlg.h"
#include "CDPlaylistDlg.h"
#include "AboutDlg.h"
#include "SeekDialog.h"
#include "MP3InfoDlg.h"
#include "SettingsDialog.h"
#include "WAEmuWnd.h"


#include "Volume.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainWnd* pMainFrame;
extern CSysTrayPlayApp theApp;
extern CSeekDialog *SeekDialog;
extern CEqualizerDlg *EqualizerDlg;
extern CPlaylistDlg *PlaylistDlg;
extern CCDPlaylistDlg *CDPlaylistDlg;
extern CAboutDlg *AboutDlg;
extern CMP3InfoDlg *MP3InfoDlg;
extern CSettingsDialog *SettingsDialog;
extern CWAEmuWnd *WAEmuWnd;

extern CVolume* pVolume;

extern void ReadAllTags();

BEGIN_MESSAGE_MAP(CTranspBmp,CStatic)
	ON_WM_PAINT()
END_MESSAGE_MAP()

CTranspBmp::CTranspBmp() : CStatic()
{
}

void CTranspBmp::Create(WORD idb, int width, int height)
{
	w=width;h=height;
	bmp=(HBITMAP)::LoadImage(theApp.m_hInstance,MAKEINTRESOURCE(idb), IMAGE_BITMAP,w,h, LR_DEFAULTCOLOR);
}

void CTranspBmp::Delete()
{
	DeleteObject(bmp);
}

void CTranspBmp::OnPaint() 
{
	CPaintDC dc(this);

    HDC hDC = CreateCompatibleDC(dc.m_hDC);

	CRect rect;
	GetClientRect(&rect);
	//int l=(rect.Width()-w)/2;
	//int t=(rect.Height()-h)/2;

	bmp = (HBITMAP)SelectObject(hDC, bmp);

	HDC hdc1=CreateCompatibleDC(dc.m_hDC);
	HDC hdc2=CreateCompatibleDC(dc.m_hDC);
	HDC hdc3=CreateCompatibleDC(dc.m_hDC);
	HDC hdc4=CreateCompatibleDC(dc.m_hDC);
	HBITMAP bm1=CreateBitmap(w,h,1,1,NULL);
	HBITMAP bm2=CreateBitmap(w,h,1,1,NULL);
	HBITMAP bm3=CreateCompatibleBitmap(hDC,w,h);
	HBITMAP bm4=CreateCompatibleBitmap(hDC,w,h);
	SelectObject(hdc1,bm1);
	SelectObject(hdc2,bm2);
	SelectObject(hdc3,bm3);
	SelectObject(hdc4,bm4);

	COLORREF cColor=SetBkColor(hDC,RGB(255, 0, 255));
  	BitBlt(hdc1,0,0,w,h,hDC,0,0,SRCCOPY);
	SetBkColor(hDC,cColor);
	BitBlt(hdc2,0,0,w,h,hdc1,0,0,NOTSRCCOPY);
	BitBlt(hdc3,0,0,w,h,hDC,0,0,SRCCOPY);	
	BitBlt(hdc3,0,0,w,h,hdc2,0,0,SRCAND);	

	CDC::FromHandle(hdc4)->FillSolidRect(0,0,w,h,(COLORREF)GetSysColor(COLOR_BTNFACE));
	
	BitBlt(hdc4,0,0,w,h, hdc1, 0, 0, SRCAND);
	
	BitBlt(hdc4,0,0,w,h, hdc3, 0, 0, SRCPAINT);

	StretchBlt(dc.m_hDC,0,0,rect.Width(),rect.Height(), hdc4, 0, 0, w, h, SRCCOPY);

	DeleteDC(hdc1);DeleteDC(hdc2);DeleteDC(hdc3);DeleteDC(hdc4);
	DeleteObject(bm1);DeleteObject(bm2);DeleteObject(bm3);DeleteObject(bm4);

	bmp = (HBITMAP)SelectObject(hDC, bmp);

	DeleteDC(hDC);
}

BEGIN_MESSAGE_MAP(CMyPrBar,CProgressCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

CMyPrBar::CMyPrBar():
	CProgressCtrl()
{
	MemDCCreated=false;
}

BEGIN_MESSAGE_MAP(CMyPrBarVol,CProgressCtrl)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_PAINT()
	ON_WM_ERASEBKGND( )
END_MESSAGE_MAP()

CMyPrBarVol::CMyPrBarVol():
	CProgressCtrl()
{
	MemDCCreated=false;
	ScrollFlag=false;
}

void CMyPrBar::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(pMainFrame->m_Player.CanSetPos())
	{
		SeekDialog->ScrollFlag=true;
		CRect rect;
		GetClientRect(&rect);
		int newpos=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)1000/(float)(rect.Width()));
		int p=(int)((float)pMainFrame->TrackDurI*(float)newpos/(float)1000);
		if(p>pMainFrame->TrackDurI) p=pMainFrame->TrackDurI;
		if(pMainFrame->ShowTTT)
			SeekDialog->CurrentTime.Format("%02d:%02d/%02d:%02d",
						   pMainFrame->ShowRemainingTime==1?(int)((pMainFrame->TrackDurI-p)/60):p/60,
						   pMainFrame->ShowRemainingTime==1?((pMainFrame->TrackDurI-p)%60):p%60,
						   pMainFrame->TrackDurI/60,pMainFrame->TrackDurI%60);
		else
			SeekDialog->CurrentTime.Format("%02d:%02d",
						   pMainFrame->ShowRemainingTime==1?(int)((pMainFrame->TrackDurI-p)/60):p/60,
						   pMainFrame->ShowRemainingTime==1?((pMainFrame->TrackDurI-p)%60):p%60);
		
		SetPos(newpos);

		SetCapture();
	}
}

void CMyPrBarVol::OnLButtonDown(UINT nFlags, CPoint point)
{
	CRect rect;
	GetClientRect(&rect);
	SetPos(pMainFrame->CurrentVolume=(int)((float)point.x*(float)100/(float)(rect.Width())));
	SetCapture();
	ScrollFlag=true;
	pVolume->SetCurrentVolume(pMainFrame->CurrentVolume);
}

void CMyPrBarVol::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(ScrollFlag)
	{
		ScrollFlag=false;
		::ReleaseCapture();
	}
}

void CMyPrBar::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(SeekDialog->ScrollFlag&&pMainFrame->m_Player.CanSetPos())
	{
		CRect rect;
		GetClientRect(&rect);
		int newpos=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)100/(float)(rect.Width()));
		pMainFrame->m_Player.SetPos(newpos);
		pMainFrame->UpdMBTR();
		SeekDialog->ScrollFlag=false;
		::ReleaseCapture();
	}
}

void CMyPrBar::OnMouseMove(UINT nFlags, CPoint point)
{
	if((nFlags&MK_LBUTTON)&&SeekDialog->ScrollFlag&&pMainFrame->m_Player.CanSetPos())
	{
		CRect rect;
		GetClientRect(&rect);
		int newpos=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)1000/(float)(rect.Width()));
		int p=(int)((float)pMainFrame->TrackDurI*(float)newpos/(float)1000);
		if(p>pMainFrame->TrackDurI) p=pMainFrame->TrackDurI;
		if(pMainFrame->ShowTTT)
			SeekDialog->CurrentTime.Format("%02d:%02d/%02d:%02d",
						   pMainFrame->ShowRemainingTime==1?(int)((pMainFrame->TrackDurI-p)/60):p/60,
						   pMainFrame->ShowRemainingTime==1?((pMainFrame->TrackDurI-p)%60):p%60,
						   pMainFrame->TrackDurI/60,pMainFrame->TrackDurI%60);
		else
			SeekDialog->CurrentTime.Format("%02d:%02d",
						   pMainFrame->ShowRemainingTime==1?(int)((pMainFrame->TrackDurI-p)/60):p/60,
						   pMainFrame->ShowRemainingTime==1?((pMainFrame->TrackDurI-p)%60):p%60);

		SetPos(newpos);
	}
}

void CMyPrBarVol::OnMouseMove(UINT nFlags, CPoint point)
{
	if(nFlags&MK_LBUTTON&&ScrollFlag)
	{
		CRect rect;
		GetClientRect(&rect);
		SetPos(pMainFrame->CurrentVolume=(int)((float)(point.x>=0?(point.x<rect.Width()?point.x:rect.Width()):0)*(float)100/(float)(rect.Width())));
		pVolume->SetCurrentVolume(pMainFrame->CurrentVolume);
	}
}

BOOL CMyPrBar::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CMyPrBar::OnPaint() 
{
	CPaintDC dc(this);
	
	if(!MemDCCreated)
	{	
		CRect rect;
		GetClientRect(&rect);

		memDC.CreateCompatibleDC(&dc);
		memBitmap.CreateCompatibleBitmap(&dc, width=rect.Width(), height=rect.Height());
		memDC.SelectObject(&memBitmap);

		MemDCCreated=true;
	}

	memDC.FillSolidRect(0,0,width,height, ::GetSysColor(COLOR_BTNFACE));

	if(SeekDialog->CurrentSong!="")
	{
		DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);
		
		CRect r;

		CFont MyFont;
		MyFont.CreatePointFont(70,"Small Fonts");
		CFont *pFont=memDC.SelectObject(&MyFont);
		int nBkMode = memDC.SetBkMode(TRANSPARENT);
		COLORREF crText=memDC.SetTextColor(::GetSysColor(COLOR_MENUTEXT));
		r.left=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits())+2;r.top=1;r.right=width-2;r.bottom=height-1;
		memDC.DrawText(SeekDialog->CurrentTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		r.left=2;r.top=1;r.right=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits());r.bottom=height-1;
		memDC.DrawText(SeekDialog->CurrentSong, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

		memDC.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		r.left=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits())+2;r.top=1;r.right=width-2;r.bottom=height-1;
		if(r.right>width*GetPos()/1000) r.right=width*GetPos()/1000+1;
		memDC.DrawText(SeekDialog->CurrentTime, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		r.left=2;r.top=1;r.right=width-(pMainFrame->ShowTTT?6.5:3.5)*LOWORD(GetDialogBaseUnits());r.bottom=height-1;
		if(r.right>width*GetPos()/1000) r.right=width*GetPos()/1000+1;
		memDC.DrawText(SeekDialog->CurrentSong, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

		memDC.SetTextColor(crText); 
		memDC.SetBkMode(nBkMode);
		memDC.SelectObject(pFont);
	} else
	{
		DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);
		
		CRect r;

		CFont MyFont;
		MyFont.CreatePointFont(70,"Small Fonts");
		CFont *pFont=memDC.SelectObject(&MyFont);
		int nBkMode = memDC.SetBkMode(TRANSPARENT);
		COLORREF crText=memDC.SetTextColor(::GetSysColor(COLOR_MENUTEXT));

		r.left=1;r.top=1;r.right=width-1;r.bottom=height-1;
		memDC.DrawText("STP MP3 player", -1, &r, DT_CENTER | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);
		
		memDC.SetTextColor(crText); 
		memDC.SetBkMode(nBkMode);
		memDC.SelectObject(pFont);
	}

	dc.BitBlt(0, 0, width, height,
				&memDC, 0, 0, SRCCOPY);
}

BOOL CMyPrBarVol::OnEraseBkgnd(CDC* pDC) 
{
	return FALSE;
}

void CMyPrBarVol::OnPaint() 
{
	CPaintDC dc(this);
	
	if(!MemDCCreated)
	{
		
		memDC.CreateCompatibleDC(&dc);
		CRect rect;
		GetClientRect(&rect);
		memBitmap.CreateCompatibleBitmap(&dc, width=rect.Width(), height=rect.Height());
		memDC.SelectObject(&memBitmap);

		MemDCCreated=true;
	}

	memDC.FillSolidRect(0,0,width,height, ::GetSysColor(COLOR_BTNFACE));

	DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, (LPARAM)0);

/*	CPen *p_pen,pen(PS_SOLID, 0, ::GetSysColor(COLOR_GRAYTEXT));
	p_pen=memDC.SelectObject(&pen);
	int i;
	for(i=1;i<7;i++)
	{
		memDC.MoveTo(width*i/7,4);
		memDC.LineTo(width*i/7,height-4);
	}*/

	CRect r;

	CString buf;
	buf.Format("%3d%%",GetPos());

	CFont MyFont;
	MyFont.CreatePointFont(70,"Small Fonts");
	CFont *pFont=memDC.SelectObject(&MyFont);
	int nBkMode = memDC.SetBkMode(TRANSPARENT);
	COLORREF crText=memDC.SetTextColor(::GetSysColor(COLOR_MENUTEXT));
	r.left=2;r.top=1;r.right=width-2;r.bottom=height-1;
	memDC.DrawText(buf, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

	memDC.SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
	r.left=2;r.top=1;r.right=width-2;r.bottom=height-1;
	if(r.right>width*GetPos()/100) r.right=width*GetPos()/100+1;
	memDC.DrawText(buf, -1, &r, DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER);

	memDC.SetTextColor(crText); 
	memDC.SetBkMode(nBkMode);
	memDC.SelectObject(pFont);

	dc.BitBlt(0, 0, width, height,
				&memDC, 0, 0, SRCCOPY);
}

/////////////////////////////////////////////////////////////////////////////
// CSeekDialog dialog


CSeekDialog::CSeekDialog(UINT id, CWnd* pParent /*=NULL*/)
	: CDialog(id, pParent)
{
	//{{AFX_DATA_INIT(CSeekDialog)
	//}}AFX_DATA_INIT
	HDocked=VDocked=true;
	ScrollFlag=false;
	CanResize=false;
}


void CSeekDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSeekDialog)
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_BAR, m_bar);
	DDX_Control(pDX, IDC_VOL, m_vol);
	DDX_Control(pDX, IDC_FORIEPT, m_ipe);
	DDX_Control(pDX, IDC_FORCONTROLS, m_mb);
}


BEGIN_MESSAGE_MAP(CSeekDialog, CDialog)
	//{{AFX_MSG_MAP(CSeekDialog)
	ON_WM_CLOSE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_LBUTTONUP()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
	ON_WM_MOVING()
	ON_WM_SIZING()
	ON_WM_DROPFILES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSeekDialog message handlers

BOOL CSeekDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText("STP MiniBar");
	ModifyStyleEx(0,WS_EX_ACCEPTFILES);

	SetTimer(1,100,NULL);

	CRect rect, rect1, rect2;
	
	m_bar.GetWindowRect(&rect);
	ScreenToClient(&rect);
	l1=rect.left; h1=rect.Height();
	m_vol.GetWindowRect(&rect);
	w1=rect.Width();
	m_ipe.GetWindowRect(&rect);
	w2=rect.Width();

	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	GetWindowRect(&rect2);
	if(pMainFrame->SeekBarW==-1000)
		pMainFrame->SeekBarW=rect2.Width();
	if(pMainFrame->SeekBarX==-1000)
		pMainFrame->SeekBarX=(rect1.right-pMainFrame->SeekBarW)/2;
	if(pMainFrame->SeekBarY==-1000)
		pMainFrame->SeekBarY=rect1.top;
	if(pMainFrame->SeekBarX<rect1.left)
		pMainFrame->SeekBarX=rect1.left;
	if(pMainFrame->SeekBarY<rect1.top)
		pMainFrame->SeekBarY=rect1.top;
	if(pMainFrame->SBDockR||pMainFrame->SeekBarX+pMainFrame->SeekBarW>rect1.right)
		pMainFrame->SeekBarX=rect1.right-pMainFrame->SeekBarW;
	if(pMainFrame->SBDockB||pMainFrame->SeekBarY+(rect2.bottom-rect2.top)>rect1.bottom)
		pMainFrame->SeekBarY=rect1.bottom-(rect2.bottom-rect2.top);

	SetWindowPos(&wndTopMost,pMainFrame->SeekBarX,pMainFrame->SeekBarY,pMainFrame->SeekBarW,rect2.Height(),SWP_NOACTIVATE);

	if(pMainFrame->DockSD)
	{
		CRect rect1,rect2,rect3,rect4;
		GetWindowRect(&rect1);
		::GetWindowRect(::GetDesktopWindow(),&rect2);
		::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
		::GetWindowRect(::FindWindow("Shell_TrayWnd",NULL),&rect4);
		SetWindowPos(NULL,(rect3.right-350)/2,(rect4.bottom<rect2.bottom)?rect3.bottom-rect1.Height():rect3.top,350,rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
	}

	GetClientRect(&rect);

	m_bar.SetWindowPos(NULL,0,0,rect.Width()-l1-w1-w2,h1,SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
	m_vol.SetWindowPos(NULL,rect.Width()-w1-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
	m_ipe.SetWindowPos(NULL,rect.Width()-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);

	m_ipe.Create(IDB_IPEN,48,15);
	m_mb.Create(IDB_MB,60,15);

	m_vol.SetRange(0,100);

	m_vol.SetPos(pMainFrame->CurrentVolume);

	m_bar.SetRange(0,1000);
	pMainFrame->UpdMBTR();

//	GetSystemMenu(FALSE)->DeleteMenu(0,MF_BYPOSITION);
//	GetSystemMenu(FALSE)->DeleteMenu(0,MF_BYPOSITION);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSeekDialog::OnClose() 
{
	SaveWindowPosAndDestroy();
}

void CSeekDialog::OnPlay() 
{
	if(pMainFrame->PlayListLength==0) return;
	switch (pMainFrame->m_Player.PlayerMode()) {
	  case pmPlaying:
		pMainFrame->m_Player.Close();
	  case pmClosed:
		pMainFrame->m_Player.InitStream();
		pMainFrame->SetOut();
		pMainFrame->m_Player.Play();
		break;
	  case pmPaused:
		pMainFrame->m_Player.Resume();
		break;
	}
	pMainFrame->UpdMBTR();
}

void CSeekDialog::OnPause() 
{
	if(pMainFrame->PlayListLength==0) return;
	switch (pMainFrame->m_Player.PlayerMode()) {
	  case pmPaused:
		pMainFrame->m_Player.Resume();
		break;
	  case pmPlaying:
		pMainFrame->m_Player.Pause();
		break;
	}
	pMainFrame->UpdMBTR();
}

void CSeekDialog::OnStop() 
{
	if(pMainFrame->PlayListLength==0) return;
	switch(pMainFrame->m_Player.PlayerMode())
	{
	case pmPaused:
	case pmPlaying:
		pMainFrame->m_Player.Close();
	}
	pMainFrame->UpdMBTR();
}

void CSeekDialog::OnNext() 
{
	if(pMainFrame->PlayListLength<2) return;

	int pm=pMainFrame->m_Player.PlayerMode();
	
	pMainFrame->m_Player.Close();
	UINT q=0;
	do
	{
		q++;
		if(pMainFrame->ShuffleMode)
			pMainFrame->Current=pMainFrame->MyRandom(true);
		else
		{
			int b,e; pMainFrame->GetAlbumRange(&b,&e);
			if(pMainFrame->Current==e)
				pMainFrame->Current=b;
			else
				pMainFrame->Current++;
		}
		pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
		if(pm==pmPaused||
			pm==pmPlaying)
		{	
			if(!pMainFrame->m_Player.InitStream()) continue;
			pMainFrame->SetOut();
			pMainFrame->m_Player.Play();
		}
		break;
	}
	while(q<pMainFrame->PlayListLength*2);

	pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
	pMainFrame->UpdMBTR();
	
	if(PlaylistDlg!=NULL)			
		PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	
}

void CSeekDialog::OnPrev() 
{
	if(pMainFrame->PlayListLength<2) return;
	int pm=pMainFrame->m_Player.PlayerMode();
	pMainFrame->m_Player.Close();
	UINT q=0;
	do
	{
		q++;
		if(pMainFrame->ShuffleMode)
			pMainFrame->Current=pMainFrame->MyRandom(false);
		else
		{
			int b,e; pMainFrame->GetAlbumRange(&b,&e);
			if(pMainFrame->Current==b)
				pMainFrame->Current=e;
			else
				pMainFrame->Current--;
		}
		pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
		if(pm==pmPaused||
			pm==pmPlaying)
		{	
			if(!pMainFrame->m_Player.InitStream()) continue;
			pMainFrame->SetOut();
			pMainFrame->m_Player.Play();
		}
		break;
	}
	while(q<pMainFrame->PlayListLength*2);
	pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
	
	pMainFrame->UpdMBTR();
	if(PlaylistDlg!=NULL)			
		PlaylistDlg->m_playlistat.RedrawWindow(NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
	
}

void CSeekDialog::OnMoving( UINT nSide, LPRECT lpRect )
{
	if(pMainFrame->DockSD)
	{
		GetWindowRect(lpRect);
		return;
	}
	CRect rect1;
    ::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	int newx=lpRect->left,newy=lpRect->top;

	if(HDocked)
	{
		if(abs(lpRect->right-rect1.right)<5)
		{
			if(abs(lpRect->right-rect1.right)>1)
			{
				newx=lpRect->left;
				HDocked=false;
			} else
				newx=rect1.right-(lpRect->right-lpRect->left);
		}
		if(abs(lpRect->left)<5)
		{
			if(abs(lpRect->left-rect1.left)>1)
			{
				newx=lpRect->left;
				HDocked=false;
			} else
				newx=rect1.left;
		}
	}
	else
	{
		if(abs(lpRect->right-rect1.right)<5)
		{
			HDocked=true;
			newx=rect1.right-(lpRect->right-lpRect->left);
		}
		if(abs(lpRect->left-rect1.left)<5)
		{
			HDocked=true;
			newx=rect1.left;
		}
	}
	if(VDocked)
	{
		if(abs(lpRect->bottom-rect1.bottom)<5)
		{
			if(abs(lpRect->bottom-rect1.bottom)>1)
			{
				newy=lpRect->top;
				VDocked=false;
			} else
				newy=rect1.bottom-(lpRect->bottom-lpRect->top);
		}
		if(abs(lpRect->top-rect1.top)<5)
		{
			if(abs(lpRect->top-rect1.top)>1)
			{
				newy=lpRect->top;
				VDocked=false;
			} else
				newy=rect1.top;
		}
	}
	else
	{
		if(abs(lpRect->bottom-rect1.bottom)<5)
		{
			VDocked=true;
			newy=rect1.bottom-(lpRect->bottom-lpRect->top);
		}
		if(abs(lpRect->top-rect1.top)<5)
		{
			VDocked=true;
			newy=rect1.top;
		}
	}

	lpRect->right=newx+(lpRect->right-lpRect->left);lpRect->left=newx;
	lpRect->bottom=newy+(lpRect->bottom-lpRect->top);lpRect->top=newy;
}

void CSeekDialog::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CPoint thePoint=point;
	ClientToScreen(&thePoint);
	CRect rect;
	GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
	if(thePoint.x>=rect.left+(rect.right-rect.left)*5/6&&
	   thePoint.x<=rect.right&&
	   thePoint.y>=rect.top+(rect.bottom-rect.top)/3&&
	   thePoint.y<=rect.bottom)
	{
		ReleaseCapture();
		SendMessage(0xA1,2,0);
	}
}

void CSeekDialog::OnRButtonUp(UINT nFlags, CPoint point) 
{
	pMainFrame->ShowPopup(2);
}

void CSeekDialog::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CPoint thePoint=point;
	ClientToScreen(&thePoint);
	CRect rect;
	GetDlgItem(IDC_FORIEPT)->GetWindowRect(&rect);
	if(thePoint.x>=rect.left&&
	   thePoint.x<=rect.right&&
	   thePoint.y>=rect.top&&
	   thePoint.y<=rect.bottom)
	{
		if(thePoint.x<rect.left+(rect.right-rect.left)*1/6)
		{
			if(pMainFrame->PlayListLength>0)
			{
				if(MP3InfoDlg==NULL)
				{
					MP3InfoDlg=new CMP3InfoDlg(GetMp3infoID);
					MP3InfoDlg->Create(GetMp3infoID,pMainFrame);
				}
				else
				{
					MP3InfoDlg->SaveWindowPosAndDestroy();
				}	
			}
		} else
		if(thePoint.x<rect.left+(rect.right-rect.left)*2/6)
		{
			if(EqualizerDlg==NULL)
			{
				EqualizerDlg=new CEqualizerDlg(GetEqualizerID);
				EqualizerDlg->Create(GetEqualizerID,pMainFrame);
			} else
			{
				EqualizerDlg->SaveWindowPosAndDestroy();
			}	
		} else
		if(thePoint.x<rect.left+(rect.right-rect.left)*3/6)
		{
			if(PlaylistDlg==NULL)
			{
				PlaylistDlg=new CPlaylistDlg(GetPlaylistID);
				PlaylistDlg->Create(GetPlaylistID,pMainFrame);
			} else
			{
				PlaylistDlg->SaveWindowPosAndDestroy();
			}
		} else
		if(thePoint.x<rect.left+(rect.right-rect.left)*4/6)
			pMainFrame->ShowTracksMenu(2);
		else
		if(thePoint.x<rect.left+(rect.right-rect.left)*5/6)
			pMainFrame->ShowTracksMenu(2, true);
		else
		{
			if(thePoint.y<rect.top+(rect.bottom-rect.top)/3)
			{
				SaveWindowPosAndDestroy();
			}
		}
	}
	else
	{
		GetDlgItem(IDC_FORCONTROLS)->GetWindowRect(&rect);
		if(thePoint.x>=rect.left&&
		   thePoint.x<=rect.right&&
		   thePoint.y>=rect.top&&
		   thePoint.y<=rect.bottom)
		{
			if(thePoint.x<rect.left+(rect.right-rect.left)*1/5)
				OnPlay();
			else
			if(thePoint.x<rect.left+(rect.right-rect.left)*2/5)
				OnPause();
			else
			if(thePoint.x<rect.left+(rect.right-rect.left)*3/5)
				OnStop();
			else
			if(thePoint.x<rect.left+(rect.right-rect.left)*4/5)
				OnPrev();
			else
				OnNext();
		}
	}
}

void CMyPrBar::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if(!SeekDialog->ScrollFlag)
	{
		pMainFrame->ShowPopup(2);
	}
}

void CMyPrBarVol::OnRButtonUp(UINT nFlags, CPoint point) 
{
	if(!pMainFrame->CDMode)
		pMainFrame->ShowPopup(2);
	else
		pMainFrame->ShowCDPopup(2);
}

void CSeekDialog::OnDropFiles(HDROP hDropInfo)
{
	TCHAR szFileName[_MAX_PATH];
	CString buf;
	UINT nFileCount = ::DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 0);
	for (UINT i=0;i<nFileCount;i++)
	{
		::DragQueryFile(hDropInfo, i, szFileName, _MAX_PATH);
		buf=szFileName;
		if(::GetFileAttributes(szFileName)&FILE_ATTRIBUTE_DIRECTORY)
		{
			if(buf[buf.GetLength()-1]!='\\')
				buf+="\\";
			pMainFrame->FindMP3Files(buf);
		}
		else
		{
			if((buf.Right(4)).CompareNoCase(".M3U")==0||(buf.Right(4)).CompareNoCase(".PLS")==0)
			{
				pMainFrame->OpenPlaylist(buf,false,false);
			}
			else
			{
				pMainFrame->PlayList.Add(buf);
				pMainFrame->PlayListAT.Add("");
			}
		}
	}

	UINT PLLPrev=pMainFrame->PlayListLength;
	pMainFrame->PlayListLength=pMainFrame->PlayList.GetSize();
	if(pMainFrame->PlayListLength>0)
	{
		if(PLLPrev==0)
		{
			pMainFrame->m_Player.Close();
			if(pMainFrame->ShuffleMode)
				pMainFrame->FirstInMyRandom=pMainFrame->Current=pMainFrame->MyRandom(true, true);
			else
			{
				pMainFrame->Current=0;pMainFrame->FirstInMyRandom=-1;
			}
			bool first=true;
			int q=0;
			do
			{
				if(!first)
				{
					if(pMainFrame->Current<pMainFrame->PlayListLength-1)
					{
						pMainFrame->Current++;
					}
					else
					{
						pMainFrame->Current=0;
						q++;
						if(pMainFrame->m_Repeat!=1)
							break;
					}
				} else first=false;
				pMainFrame->m_Player.SetInName(pMainFrame->PlayList[pMainFrame->Current]);
				if(!pMainFrame->m_Player.InitStream()) continue;
				if(pMainFrame->AutoPlay)
				{
					pMainFrame->SetOut();
					pMainFrame->m_Player.Play();
				} else pMainFrame->m_Player.Close();
				break;
			}
			while(q<2);
			pMainFrame->ReadTag(pMainFrame->PlayList[pMainFrame->Current]);
		}
		pMainFrame->UpdMBTR();
		if(PlaylistDlg!=NULL)
		{
			PlaylistDlg->FillPlaylist();
			PlaylistDlg->ShowFileName();
		}
		ReadAllTags();
	}
	::DragFinish(hDropInfo);
}

void CSeekDialog::OnDestroy() 
{
	CDialog::OnDestroy();
	
	m_ipe.Delete();
	m_mb.Delete();
}

void CSeekDialog::SaveWindowPosAndDestroy()
{
	ShowWindow(SW_RESTORE);
	CRect rect;
	GetWindowRect(&rect);
	pMainFrame->SeekBarX=rect.left;
	pMainFrame->SeekBarY=rect.top;
	pMainFrame->SeekBarW=rect.Width();
	CRect rect1;
	::SystemParametersInfo(SPI_GETWORKAREA,0,&rect1,0);
	pMainFrame->SBDockR=((rect.right==rect1.right&&!pMainFrame->DockSD)?1:0);
	pMainFrame->SBDockB=((rect.bottom==rect1.bottom&&!pMainFrame->DockSD)?1:0);

	DestroyWindow();
	SeekDialog=NULL;
}


void CSeekDialog::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent==1)
	{
		if(pMainFrame->DockSD)
		{
			HWND w=::GetForegroundWindow();
			if(w!=NULL&&
			   w!=pMainFrame->m_hWnd&&
			   !(::GetWindow(w, GW_OWNER)!=NULL&&::GetWindow(w, GW_OWNER)==pMainFrame->m_hWnd)&&
			   !(::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER)!=NULL&&::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER)==pMainFrame->m_hWnd)&&
			   !(::GetWindow(::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER), GW_OWNER)!=NULL&&::GetWindow(::GetWindow(::GetWindow(w, GW_OWNER), GW_OWNER), GW_OWNER)==pMainFrame->m_hWnd)&&
			   w!=::FindWindow("Shell_TrayWnd",NULL))
			{
				CRect rect, rect1, rect2;
				::GetWindowRect(w,&rect);
				::GetWindowRect(::GetDesktopWindow(),&rect2);
				GetWindowRect(&rect1);
				int sbcnt=((::GetWindowLong(w,GWL_STYLE)&WS_SYSMENU)?1:0)+((::GetWindowLong(w,GWL_STYLE)&WS_MINIMIZEBOX)?1:0)+((::GetWindowLong(w,GWL_STYLE)&WS_MINIMIZEBOX)?1:0);
				if(rect==rect2||(::IsWindowVisible(w)&&(::GetWindowLong(w,GWL_STYLE)&WS_CAPTION)&&!(::GetWindowLong(w,GWL_EXSTYLE)&WS_EX_TOOLWINDOW))&&!(::GetWindowLong(w,GWL_EXSTYLE)&WS_EX_TOPMOST)&&rect.Width()-GetSystemMetrics(SM_CXSIZE)*((float)sbcnt+.5)>200)
				{
					int neww=200;
					if(rect.Width()>350) neww=250;
					if(rect.Width()>550) neww=300;
					if(rect.Width()>700) neww=350;
					int newx=rect.right-neww-GetSystemMetrics(SM_CXSIZE)*((float)sbcnt+.5);
					int newy=rect.top+((::GetWindowLong(w,GWL_STYLE)&WS_THICKFRAME)?1:0);
					if(rect==rect2)
					{
						CRect rect3,rect4;
						::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
						::GetWindowRect(::FindWindow("Shell_TrayWnd",NULL),&rect4);
						SetWindowPos(NULL,(rect3.right-350)/2,(rect4.bottom<rect2.bottom)?rect3.bottom-rect1.Height():rect3.top,350,rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
					}
					else
					{
						if(newx!=rect1.left||newy!=rect1.top)
							SetWindowPos(NULL,newx,newy,neww,rect1.Height(),SWP_NOZORDER | SWP_NOACTIVATE);
					}
				}
			} else
			if(w==NULL)
			{
				CRect rect1,rect2,rect3,rect4;
				GetWindowRect(&rect1);
				::GetWindowRect(::GetDesktopWindow(),&rect2);
				::SystemParametersInfo(SPI_GETWORKAREA,0,&rect3,0);
				::GetWindowRect(::FindWindow("Shell_TrayWnd",NULL),&rect4);
				SetWindowPos(NULL,(rect3.right-350)/2,(rect4.bottom<rect2.bottom)?rect3.bottom-rect1.Height():rect3.top,350,rect1.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
			}
		}
		return;
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CSeekDialog::OnSizing( UINT nSide, LPRECT lpRect )
{
	if(pMainFrame->DockSD)
	{
		GetWindowRect(lpRect);
		return;
	}
	CRect r;
	GetWindowRect(&r);
	lpRect->top=r.top;
	lpRect->bottom=r.bottom;
	if(lpRect->right-lpRect->left<200)
	{
		if(lpRect->left>r.left)
			lpRect->left=lpRect->right-200;
		else
			lpRect->right=lpRect->left+200;
	}
}

void CSeekDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(CanResize)
	{
		m_bar.memDC.DeleteDC();
		m_bar.memBitmap.DeleteObject();
		m_bar.MemDCCreated=false;	

		CRect rect;
		GetClientRect(&rect);

		m_bar.SetWindowPos(NULL,0,0,rect.Width()-l1-w1-w2,h1,SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_vol.SetWindowPos(NULL,rect.Width()-w1-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_ipe.SetWindowPos(NULL,rect.Width()-w2,0,0,0,SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
		m_bar.RedrawWindow();
		m_vol.RedrawWindow();
		m_ipe.RedrawWindow();
	}
}

void CSeekDialog::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	CanResize=bShow?true:false;	
}
